unit Vrgisman;


interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Printers, ClipBrd,
  ComCtrls, ExtCtrls, Menus, ToolWin;


type
  TVrManager = class(TForm)
    VrMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    HelpContentsItem: TMenuItem;
    HelpOnHelpItem: TMenuItem;
    HelpMeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    StatusLine: TStatusBar;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    PrintSetupDialog: TPrinterSetupDialog;
    Tools1: TMenuItem;
    MRUItem: TMenuItem;
    RemoteControl1: TMenuItem;
    TaskCommander1: TMenuItem;
    RichEdit1: TRichEdit;
    Date1: TMenuItem;
    N1: TMenuItem;
    N5: TMenuItem;
    Options1: TMenuItem;
    LaunchVRGISprograms1: TMenuItem;
    ProgramManager: TMenuItem;
    N3: TMenuItem;
    N7: TMenuItem;
    Font1: TMenuItem;
    SpeedBar: TPanel;
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    PrintButton: TSpeedButton;
    UndoButton: TSpeedButton;
    CutButton: TSpeedButton;
    CopyButton: TSpeedButton;
    PasteButton: TSpeedButton;
    Bevel1: TBevel;
    BoldButton: TSpeedButton;
    ItalicButton: TSpeedButton;
    LeftAlign: TSpeedButton;
    CenterAlign: TSpeedButton;
    RightAlign: TSpeedButton;
    UnderlineButton: TSpeedButton;
    BulletsButton: TSpeedButton;
    FontName: TComboBox;
    FontSize: TEdit;
    UpDown1: TUpDown;
    Ruler: TPanel;
    FirstInd: TLabel;
    LeftInd: TLabel;
    RulerLine: TBevel;
    RightInd: TLabel;
    FontDialog1: TFontDialog;
    ViewCommander1: TMenuItem;
    ReopenMenu: TMenuItem;
    Reopen0: TMenuItem;
    Reopen1: TMenuItem;
    Reopen2: TMenuItem;
    Reopen3: TMenuItem;
    Reopen4: TMenuItem; { E&xit }
    procedure RichEdit1SelectionChange(Sender: TObject);
        
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
procedure DisplaySplashScreen;
{   procedure FormActivate(Sender: TObject);}

    procedure HelpContents(Sender: TObject);
    procedure HelpSearch(Sender: TObject);
    procedure HelpHowToUse(Sender: TObject);
    procedure HelpAbout(Sender: TObject);

    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
procedure OpenFile(Filename:String);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FilePrintSetup(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure Date1Click(Sender: TObject);

    procedure Options1Click(Sender: TObject);



    procedure TaskCommander1Click(Sender: TObject);
    procedure RemoteControl1Click(Sender: TObject);


    procedure LaunchVRGISprograms1Click(Sender: TObject);
    procedure ProgramManagerClick(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure RulerResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure BoldButtonClick(Sender: TObject);
    procedure ItalicButtonClick(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure AlignButtonClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure UnderlineButtonClick(Sender: TObject);
    procedure BulletsButtonClick(Sender: TObject);
    procedure LeftIndMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LeftIndMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RightIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ViewCommander1Click(Sender: TObject);
    procedure Reopen0Click(Sender: TObject);
    procedure Reopen1Click(Sender: TObject);
    procedure Reopen2Click(Sender: TObject);
    procedure Reopen3Click(Sender: TObject);
    procedure Reopen4Click(Sender: TObject);
procedure ResetFileMenu;
    procedure FormActivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FFileName: String;
    Firstime, FUpdating: Boolean;
    FDragOfs: Integer;
    FDragging: Boolean;
    function CurrText: TTextAttributes;
    procedure GetFontNames;
    procedure SetFileName(const FileName: String);
    procedure CheckFileSave;
    procedure SetupRuler;
    procedure SetEditRect;
  public
    {INT_FormCount : integer;
    procedure OnPluginClick(Sender: TObject);}
  end;

var
  VrManager: TVrManager;

implementation
uses
  Shellapi,  {FmxUtils,} vrGlobals,
  vrAbout, AllSplash,
  {exHaust_sys_pluginmodule,}
  vrPOFrm,
  vrTaskConnectFrm,
  {vrViewCommanderFrm, }
  vrrControlFrm,
  VrgisProjman,
  vrLaunchFrm; {MDI in this programs SAME directory... use SAME Help!}

const
  RulerAdj = 4/3;
  GutterWid = 6;

{$R *.DFM}
procedure TVrManager.RichEdit1SelectionChange(Sender: TObject);
begin
  with RichEdit1.Paragraph do
  try
    FUpdating := True;
    FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
    LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
    RightInd.Left := Ruler.ClientWidth-6-Trunc((RightIndent+GutterWid)*RulerAdj);
    BoldButton.Down := fsBold in RichEdit1.SelAttributes.Style;
    ItalicButton.Down := fsItalic in RichEdit1.SelAttributes.Style;
    UnderlineButton.Down := fsUnderline in RichEdit1.SelAttributes.Style;
    BulletsButton.Down := Boolean(Numbering);
    FontSize.Text := IntToStr(RichEdit1.SelAttributes.Size);
    FontName.Text := RichEdit1.SelAttributes.Name;
    case Ord(Alignment) of
      0: LeftAlign.Down := True;
      1: RightAlign.Down := True;
      2: CenterAlign.Down := True;
    end;
  finally
    FUpdating := False;
  end;
end;

function TVrManager.CurrText: TTextAttributes;
begin
  if RichEdit1.SelLength > 0 then
    Result := RichEdit1.SelAttributes
  else
    Result := RichEdit1.DefAttributes;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TVrManager.GetFontNames;
var
  DC: HDC;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

procedure TVrManager.SetFileName(const FileName: String);
begin
  FFileName := FileName;
  Caption := Format('%s - %s', [ExtractFileName(FileName), Application.Title]);
end;

procedure TVrManager.CheckFileSave;
var SaveResp: Integer;
begin
  if RichEdit1.Modified then
  begin
    SaveResp := MessageDlg(Format('Save changes to %s?', [FFileName]),
                           mtConfirmation, mbYesNoCancel, 0);
    case SaveResp of
      idYes: FileSave(Self);
      idNo: {Nothing};
      idCancel: {Abort};
    end;
  end;
end;

procedure TVrManager.SetupRuler;
var
  I: Integer;
  S: String;
begin
  SetLength(S, 201);
  I := 1;
  while I < 200 do
  begin
    S[I] := #9;
    S[I+1] := '|';
    Inc(I, 2);
  end;
  Ruler.Caption := S;
end;

procedure TVrManager.SetEditRect;
var
  R: TRect;
begin
  with RichEdit1 do
  begin
    R := Rect(GutterWid, 0, ClientWidth-GutterWid, ClientHeight);
    SendMessage(Handle, EM_SETRECT, 0, Longint(@R));
  end;
end;

{ Event Handlers }
///////////////////////////////////////////////////////



(******************************************************)
(******************************************************)

procedure TVrManager.FileNew(Sender: TObject);
begin  { Add code to create a new file }
  CheckFileSave;
  SetFileName('Untitled');
  RichEdit1.Lines.Clear;
  RichEdit1.Modified := False;
end;

procedure TVrManager.FileOpen(Sender: TObject);
begin
    { Add code to open OpenDialog.FileName
    Shape File|shp|Digital Line Graph|dlg|DXF vectors|dxf|Database|db|Text|txt }
  OpenDialog.Filter := 'Text files (*.txt)|*.txt;*.rtf';
  OpenDialog.InitialDir:=VRGISPath;
  {Extractfilepath(Application.exename);}
  if OpenDialog.Execute then
  begin
  Application.ProcessMessages;
  if FileExists(OpenDialog.FileName) then
  begin
  OldFileName4:=OldFileName3;
  OldFileName3:=OldFileName2;
  OldFileName2:=OldFileName1;
  OldFileName1:=OldFileName0;
  OldFileName0:=OpenDialog.FileName;
      OldPath:=VRGISPath;
      VRGISPath := ExtractFilePath(OpenDialog.Filename);
      VRGISName := ExtractFileName(OpenDialog.Filename);
  ResetFileMenu;
     OpenFile(VRGISName);
  end;

  end;
end;
procedure TVrManager.OpenFile(Filename:String);
begin
    CheckFileSave;
    RichEdit1.Lines.LoadFromFile(VRGISPath+FileName);
    AutoFileOpenLastOpenedName:=VRGISPath+FileName;
    SetFileName(VRGISPath+FileName);
    RichEdit1.SetFocus;
    RichEdit1.Modified := False;
    RichEdit1.ReadOnly := ofReadOnly in OpenDialog.Options;
end;


procedure TVrManager.FileSave(Sender: TObject);
begin
   { Add code to save current file under current name }
  if FFileName = 'Untitled' then
    FileSaveAs(Sender)
  else
  begin
    If UpperCase(ExtractFileExt(FFileName)) = '.TXT' then
    RichEdit1.PlainText := True;
    RichEdit1.Lines.SaveToFile(VRGISPath+FFileName);
    RichEdit1.PlainText := False;     
    RichEdit1.Modified := False;
    AutoFileOpenLastSavedName:=VRGISPath+FFileName;
  end;   
end;

procedure TVrManager.FileSaveAs(Sender: TObject);
begin  {Shape File|shp|Digital Line Graph|dlg|DXF vectors|dxf|Database|db}
    { Add code to save current file under SaveDialog.FileName }
  SaveDialog.Filter := 'Text files|*.TXT;*.RTF';
  if SaveDialog.Execute then
  begin
    if FileExists(SaveDialog.FileName) then
      if MessageDlg(Format('OK to overwrite %s', [SaveDialog.FileName]),
        mtConfirmation, mbYesNoCancel, 0) <> idYes then Exit;
    If UpperCase(ExtractFileExt(SaveDialog.FileName)) = '.TXT' then
    RichEdit1.PlainText := True;
    RichEdit1.Lines.SaveToFile(SaveDialog.FileName);
    AutoFileOpenLastSavedName:=SaveDialog.FileName;
    SetFileName(SaveDialog.FileName);
    RichEdit1.PlainText := False;
    RichEdit1.Modified := False;
  end;
end;



procedure TVrManager.FilePrint(Sender: TObject);
begin       { Add code to print current file }
  if PrintDialog.Execute then
  begin
     RichEdit1.Print(FFileName);
  end;
end;

procedure TVrManager.FilePrintSetup(Sender: TObject);
begin
  PrintSetupDialog.Execute;
end;

procedure TVrManager.FileExit(Sender: TObject);
begin
  Close;
end;

procedure TVrManager.EditUndo(Sender: TObject);
begin
  { Add code to perform Edit Undo }
  with RichEdit1 do
    if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);  
end;

procedure TVrManager.EditCut(Sender: TObject);
begin   { RichEdit1   Add code to perform Edit Cut }
  RichEdit1.CutToClipboard;
end;

procedure TVrManager.EditCopy(Sender: TObject);
begin    { Add code to perform Edit Copy }
  RichEdit1.CopyToClipboard;
end;

procedure TVrManager.EditPaste(Sender: TObject);
begin
  { Add code to perform Edit Paste }
  RichEdit1.PasteFromClipboard;  
end;
(******************************************************)
(******************************************************)
procedure TVrManager.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_ESCAPE) and Printer.Printing then
  begin
  Printer.Abort;
  MessageDlg('Printing aborted', mtInformation, [mbOK],0);
  end;
    if (Key=VK_ESCAPE) then Close;
end;

procedure TVrManager.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  try
    CheckFileSave;
  except
    CanClose := False;
  end;
end;

procedure TVrManager.Date1Click(Sender: TObject);
begin
  if RichEdit1.SelLength > 0 then RichEdit1.SelText:=DateToStr(Date)
  else
    RichEdit1.SelText:=DateToStr(Date);
end;

procedure TVrManager.Font1Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(RichEdit1.SelAttributes);
  if FontDialog1.Execute then
    CurrText.Assign(FontDialog1.Font);
  RichEdit1.SetFocus;
end;

procedure TVrManager.RulerResize(Sender: TObject);
begin
  RulerLine.Width := Ruler.ClientWidth - (RulerLine.Left*2);
end;

procedure TVrManager.FormResize(Sender: TObject);
begin
  SetEditRect;
  RichEdit1SelectionChange(Sender);
end;

procedure TVrManager.FormPaint(Sender: TObject);
begin
  SetEditRect;
end;

procedure TVrManager.BoldButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if BoldButton.Down then
    CurrText.Style := CurrText.Style + [fsBold]
  else
    CurrText.Style := CurrText.Style - [fsBold];
end;

procedure TVrManager.ItalicButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if ItalicButton.Down then
    CurrText.Style := CurrText.Style + [fsItalic]
  else
    CurrText.Style := CurrText.Style - [fsItalic];
end;

procedure TVrManager.FontSizeChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Size := StrToInt(FontSize.Text);
end;

procedure TVrManager.AlignButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  RichEdit1.Paragraph.Alignment := TAlignment(TControl(Sender).Tag);
end;

procedure TVrManager.FontNameChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Name := FontName.Items[FontName.ItemIndex];
end;

procedure TVrManager.UnderlineButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if UnderlineButton.Down then
    CurrText.Style := CurrText.Style + [fsUnderline]
  else
    CurrText.Style := CurrText.Style - [fsUnderline];
end;


procedure TVrManager.BulletsButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  RichEdit1.Paragraph.Numbering := TNumberingStyle(BulletsButton.Down);
end;

{ Ruler Indent Dragging }
procedure TVrManager.LeftIndMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FDragOfs := (TLabel(Sender).Width div 2);
  TLabel(Sender).Left := TLabel(Sender).Left+X-FDragOfs;
  FDragging := True;
end;

procedure TVrManager.LeftIndMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if FDragging then
    TLabel(Sender).Left :=  TLabel(Sender).Left+X-FDragOfs
end;
procedure TVrManager.LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  RichEdit1.Paragraph.LeftIndent := Trunc((LeftInd.Left+FDragOfs-GutterWid) / RulerAdj)-RichEdit1.Paragraph.FirstIndent;
  RichEdit1SelectionChange(Sender);
end;

procedure TVrManager.FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  RichEdit1.Paragraph.FirstIndent := Trunc((FirstInd.Left+FDragOfs-GutterWid) / RulerAdj);
  LeftIndMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TVrManager.RightIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  RichEdit1.Paragraph.RightIndent := Trunc((Ruler.ClientWidth-RightInd.Left+FDragOfs-2) / RulerAdj)-2*GutterWid;
  RichEdit1SelectionChange(Sender);
end;
(******************************************************)
(******************************************************)





(******************************************************)
(******************************************************)
procedure TVrManager.Reopen0Click(Sender: TObject);
begin
If ((OldFileName0<>' ')and (FileExists(OldFileName0))) then
begin
    VRGISPath := ExtractFilePath(OldFileName0);
    VRGISName := ExtractFileName(OldFileName0);
    OpenFile(VRGISName);
end else
begin
OldFileName0:=' ';
ResetFileMenu;
end;
end;

procedure TVrManager.Reopen1Click(Sender: TObject);
begin
If ((OldFileName1<>' ')and (FileExists(OldFileName1))) then
begin
    VRGISPath := ExtractFilePath(OldFileName1);
    VRGISName := ExtractFileName(OldFileName1);
    OpenFile(VRGISName);
end else
begin
OldFileName1:= ' ';
ResetFileMenu;
end;
end;

procedure TVrManager.Reopen2Click(Sender: TObject);
begin
If ((OldFileName2<>' ')and (FileExists(OldFileName2))) then
begin
    VRGISPath := ExtractFilePath(OldFileName2);
    VRGISName := ExtractFileName(OldFileName2);
    OpenFile(VRGISName);
end else
begin
OldFileName2:=' ';
ResetFileMenu;
end;
end;

procedure TVrManager.Reopen3Click(Sender: TObject);
begin
If ((OldFileName3<>' ')and (FileExists(OldFileName3))) then
begin
    VRGISPath := ExtractFilePath(OldFileName3);
    VRGISName := ExtractFileName(OldFileName3);
    OpenFile(VRGISName);
end else
begin
OldFileName3:=' ';
ResetFileMenu;
end;
end;

procedure TVrManager.Reopen4Click(Sender: TObject);
begin
If ((OldFileName4<>' ')and (FileExists(OldFileName4))) then
begin
    VRGISPath := ExtractFilePath(OldFileName4);
    VRGISName := ExtractFileName(OldFileName4);
    OpenFile(VRGISName);
end else
begin
OldFileName4:=' ';
ResetFileMenu;
end;
end;

procedure TVrManager.ResetFileMenu;
begin     {}
If (OldFileName0=' ') then
   begin
   OldFileName0:= OldFileName1;
   OldFileName1:=' ';
   end;
If (OldFileName1=' ') then
   begin
   OldFileName1:= OldFileName2;
   OldFileName2:=' ';
   end;
If (OldFileName2=' ') then
   begin
   OldFileName2:= OldFileName3;
   OldFileName3:=' ';
   end;
If (OldFileName3=' ') then
   begin
   OldFileName3:= OldFileName4;
   OldFileName4:=' ';
   end;
Reopen0.Caption:= '&0 '+ OldFileName0;
Reopen1.Caption:= '&1 '+ OldFileName1;
Reopen2.Caption:= '&2 '+ OldFileName2;
Reopen3.Caption:= '&3 '+ OldFileName3;
Reopen4.Caption:= '&4 '+ OldFileName4;
end;
(******************************************************)
(******************************************************)

(******************************************************)
(******************************************************)
procedure TVrManager.HelpContents(Sender: TObject);
begin
  Application.HelpContext(0);
{  Application.HelpCommand(HELP_CONTENTS, 0);}
end;

procedure TVrManager.HelpSearch(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
{const
  EmptyString: PChar = '';
  Application.HelpCommand(HELP_PARTIALKEY, Longint(EmptyString));}
end;

procedure TVrManager.HelpHowToUse(Sender: TObject);
begin
  Application.HelpContext(100);
end;

procedure TVrManager.HelpAbout(Sender: TObject);
begin
  { Add code to show program's About Box }
  About.Show;
{  with TAboutBox.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;   }
end;
(******************************************************)
(******************************************************)

(******************************************************)
(******************************************************)
procedure TVrManager.Options1Click(Sender: TObject);
begin
  vrPOFForm.show;
end;


procedure TVrManager.RemoteControl1Click(Sender: TObject);
begin {Remote Control  NameLabel   RClientForm}
  RControlForm.Show;
end;
procedure TVrManager.TaskCommander1Click(Sender: TObject);
begin {Task Commander}
    AvrTaskConnectFrm.Show;
end;

procedure TVrManager.ViewCommander1Click(Sender: TObject);
begin
 { ViewCommanderForm.Show; }
end;


procedure TVrManager.ProgramManagerClick(Sender: TObject);
begin
  aaProjForm.show;
end;

procedure TVrManager.LaunchVRGISprograms1Click(Sender: TObject);
begin
  vrLaunchForm.show;
end;
(******************************************************)
(******************************************************)
procedure TVrManager.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainfrmX := VrManager.left;
  MainfrmY := VrManager.top;
  DoSaver;
end;

procedure TVrManager.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;
procedure TVrManager.DisplaySplashScreen;
begin
  SplashScreen := TSplashScreen.Create(Application);
  SplashScreen.SplashSet(12,2000);
  SplashScreen.Show;
  SplashScreen.Refresh;
end;

procedure TVrManager.FormActivate(Sender: TObject);
begin
{procedure TVrManager.FormActivate(Sender: TObject);
var
  PluginItem : TMenuItem;
  I          : integer;
begin
  if INT_FormCount < 1 then begin
    LoadPlugins(Self);
    for I := 0 to Length(INT_Plugins) - 1 do begin
      PluginItem := NewItem(INT_Plugins[I].Name, scNone, False, True, OnPluginClick, 0, '');
      PluginItem.Tag := I;
      MPlugins.Items.Add(PluginItem);
    end;
  end;
  Inc(INT_FormCount);
end;
procedure TVrManager.OnPluginClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
  if (Sender as TMenuItem).Checked then begin
    INT_Plugins[TMenuItem(Sender).Tag].Command('showform');
    INT_Plugins[TMenuItem(Sender).Tag].Command('version');
  end
  else
    INT_Plugins[TMenuItem(Sender).Tag].Command('hideform')
end;}
end;

procedure TVrManager.FormCreate(Sender: TObject);
var
Helps:String;
  i:Integer;
begin
  If (not SkipIntroScreen) then DisplaySplashScreen;
  if FileExists(ExtractFilePath(ParamStr(0)) + 'vrgis.pof') then
  begin
    DoLoader;
  end else begin
    MainfrmX := 0;
    MainfrmY := 0;
  LaunchFormX:=123;LaunchFormY:=123;
  aaProjFormX:=123;aaProjFormY:=123;
  ViewCommanderFormX:=123;
  ViewCommanderFormY:=123;
  RControlFormX:=123;
  RControlFormY:=123;
  ProcListFormX:=123;
  ProcListFormY:=123;
  FilesFormX:=123;
  FilesFormY:=123;
  AvrTaskConnectFrmX:=123;
  AvrTaskConnectFrmY:=123;
  MessageX:=123;MessageY:=123;
    AboutY := 123;
    AboutX := 123;
    POFFormY := 123;
    POFFormX := 123;

  CurrentColor:=clBlack;
  MapBordersColor:=clLime;
  MapBacksColor:=clWhite;
  MapDatasColor:=clYellow;
  MapGridsColor:=clRed;
{  Color256S := 8;
  SeedNumber:=32;
  SelectionRadius:=2;}
  FilePreviews:=True;
  Skip32BitNotice:=False;
  SkipIntroScreen:=False;
  ErrorBeepOn:=False;
  WarningBeepOn:=False;
  InfoBeepOn :=False;
  ConfirmBeepOn:=False;
  CompletedBeepOn:=False;
    PrintBigChecked:=True;
    UseThumbnails:=False;
    StartedNameNumber := 'Not Registered';
    Started := Date;
    Colorreg := 123;
  RandSeed:=8111953;
    Helps:='';
    HiddenString:=
      'VR GIS 1.2 Copyright, 2004: Ivan Lee Herring';
    For i:=length(HiddenString) to 254 do
    Helps:= Helps + char(random(128)+32);
    HiddenString:=
      'VR GIS 1.2 Copyright, 2004: Ivan Lee Herring'
      +Helps;
  ProjectName:=ExtractFileName(ParamStr(0));
  MapName:=ProjectName;
  TempMsgname:='';{Passing name}
  VRMProgramPath := (ParamStr(0));
  Fractal3DPath:=VRMProgramPath;
  LifePath:=VRMProgramPath;
  SOSMAPPath:=VRMProgramPath;
  ProgramPath:=VRMProgramPath;
  TracerPath:=VRMProgramPath;
  VRGISPath:=VRMProgramPath;
  DTMPath:=VRMProgramPath;
  VectorPath:=VRMProgramPath;
  GripPath:=VRMProgramPath;
  ILHallPath:=VRMProgramPath;
  NoNamePath:=VRMProgramPath;
  ProjectPath:=ExtractFilePath(ParamStr(0));
{  VRMProgramPath:=ProjectPath;}
  TransSearchDir:=ProjectPath;
  ThumbPath:=ProjectPath;
  DotPath:=ProjectPath;
  SDTSPath:=ProjectPath;
  TigerPath:=ProjectPath;
  DLGPath:=ProjectPath;
  MapsPath:=ProjectPath;
  DXFPath:=ProjectPath;
  ShapePath:=ProjectPath;
  VRMDatabase:=ProjectPath;
  ImageryPath:=ProjectPath;
  OldPath:=ProjectPath;
  OldFileName4:='';OldFileName3:='';OldFileName2:='';
  OldFileName1:='';OldFileName0:='';
  {Remote Controller input IS Drone IP}
  RCEHostname:='169.254.126.197';
  RCEPort:='23';
  RCPasswordEdit:='Remote Control Password';
  //Task Commander input is the DRONE IP ..
  //List is ALL those it CAN connect to..
  //so far..limited to 8
  vrTaskIP0:='169.254.126.197'; {198 is Compaq, 197 is Inteva}
  vrTaskIP1:='';  vrTaskIP2:='';  vrTaskIP3:='';
    vrTaskIP4:='';  vrTaskIP5:='';  vrTaskIP6:='';  vrTaskIP7:='';
  vrTaskPassword :='Task Password';
  vrTaskPort0:= '2345';
  vrTaskPort1:='';  vrTaskPort2:='';  vrTaskPort3:='';
    vrTaskPort4:='';  vrTaskPort5:='';  vrTaskPort6:='';  vrTaskPort7:='';

//Viewer Gets-Displays locations of all others from server
//Server LOGS all the Clients Talking TO it
//SO what do i want to DO ?
  ViewCommanderEPort:='27456';
  ViewCommanderIPPort:='169.254.126.198';{198 is Compaq, 197 is Inteva}

    ThumbColor:=clWhite;
    ThumbSize:=128;     {ThumbWidth:=128;    ThumbHeight:=96;}
    ThumbPath:=ProjectPath;
  AutoFileOpenRGIndex:=3;   {AutoFileOpenNameEdit}
  AutoFileOpenName:= ProjectPath+'Notes to Self.rtf';
    DoSaver;
  end;
{  ServerActiveCount:=0;}
{Check Defaults and Change Menu...}
Reopen0.Caption:= '&0 '+ OldFileName0;
Reopen1.Caption:= '&1 '+ OldFileName1;
Reopen2.Caption:= '&2 '+ OldFileName2;
Reopen3.Caption:= '&3 '+ OldFileName3;
Reopen4.Caption:= '&4 '+ OldFileName4;

  MMSysHandle := LoadLibrary('WINMM.DLL');
  if (MMSysHandle <> 0) then
  begin
    @PlaySound := GetProcAddress(MMSysHandle, 'sndPlaySoundA');
  end else
  begin
    MMSysHandle := LoadLibrary('MMSYSTEM.DLL');
    if (MMSysHandle <> 0) then
    begin
      @PlaySound := GetProcAddress(MMSysHandle, 'sndPlaySound');
    end;
  end;
  if (MMSysHandle = 0) then DoMessages(22222);
  OldPath:=VRGISPath;
  Application.HelpFile := ExtractFilePath(ParamStr(0))+ 'vrgis.hlp';
  Application.OnHint := ShowHint;
    top := MainfrmY;
    Left := MainfrmX;
  {INT_FormCount := 0;}
  OpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
  SaveDialog.InitialDir := OpenDialog.InitialDir;
  SetFileName('Untitled');
  GetFontNames;
  SetupRuler;
  RichEdit1SelectionChange(Self);
  RichEdit1.Modified := False;
  Firstime:=True;
end;
(******************************************************)
(******************************************************)


procedure TVrManager.FormShow(Sender: TObject);
var Helps:String;
begin
  If Firstime then
  begin
  Firstime:=False;
  if ({(ParamCount = 1)and}(FileExists(ParamStr(1)))) then
   // if UpperCase(ExtractFileExt(ParamStr(1))) = '.RTF' TXT DOC then
    begin
      OldFileName4:=OldFileName3;
      OldFileName3:=OldFileName2;
      OldFileName2:=OldFileName1;
      OldFileName1:=OldFileName0;
      OldFileName0:=ParamStr(1);
      VRGISName := ExtractFileName(ParamStr(1));
      OldPath:=VRGISPath;
      VRGISPath := ExtractFilePath(ParamStr(1));
      OpenFile(VRGISName);
    end
    else
  if FFileName = 'Untitled' then
  begin
  Helps:='';
  Case AutoFileOpenRGIndex of
  1:Helps:=AutoFileOpenLastSavedName;
  2:Helps:=AutoFileOpenLastOpenedName;
  3:Helps:= AutoFileOpenName;
  end; ///case
    If FileExists(Helps) then
    begin
      RichEdit1.Modified:=False;
      VRGISName :=ExtractFileName(Helps);
      OldPath:=VRGISPath;
      VRGISPath := ExtractFilePath(Helps);
      OpenFile(VRGISName);
    end;
  end;
  end;
end;

end.
