unit sosmapcmd;

{ 06.02.2k3 - folken - unit created }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,ComCtrls,
  net_clientlist, net_account,
  IdBaseComponent, IdComponent, IdTCPServer, IdSocketHandle;

type
  Tsosmapcmdform = class(TForm)
    BConnect: TButton;
    BDisconnect: TButton;
    LPort: TLabel;
    EPort: TEdit;
    LBClients: TListBox;
    MStatus: TMemo;
    BUpdate: TButton;
    SBStatus: TStatusBar;
    IdTCPServer1: TIdTCPServer;
    IPPort: TEdit;
    Label1: TLabel;
    procedure BConnectClick(Sender: TObject);
    procedure BDisconnectClick(Sender: TObject);
//    procedure ServerAccept(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ServerClientConnect(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ServerClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ServerClientWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
//    procedure ServerListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure BUpdateClick(Sender: TObject);
    procedure MStatusChange(Sender: TObject);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
    procedure IdTCPServer1Exception(AThread: TIdPeerThread;
      AException: Exception);
  private
    INT_Clients  : TClientList;
    INT_Accounts : TAccounts;
    procedure UpdateClients;
    procedure LogClientRead(Message : string);
  public
  end;

var
  sosmapcmdform: Tsosmapcmdform;

implementation

uses
  VectorGeometry,
  sys_directories,
  net_types;

{$R *.dfm}

// formcreate
//
procedure Tsosmapcmdform.FormCreate(Sender: TObject);
var
  F:Textfile;
  S: string;
begin
  INT_Clients := TClientlist.Create;
  INT_Accounts := TAccounts.Create;
  INT_Accounts.LoadFromFile(DIR_Data + 'accounts\accounts.scp');
  SBStatus.Panels[2].Text := 'accounts : ' + IntToStr(INT_Accounts.Count);
  If FileExists(Extractfilepath(Application.exename)+'smsad.txt') then
  begin
    AssignFile(F, Extractfilepath(Application.exename)+'smsad.txt');
    Reset(F);
    Readln(F, S);
    IPPort.Text := S;
    Readln(F, S);
    EPort.Text := S;
    Readln(F, S);
    top := strtoint(S);
    Readln(F, S);
    left := strtoint(S);
    CloseFile(F);
  end;{Then use the text in the edits}
end;

// formclose
//
procedure Tsosmapcmdform.FormClose(Sender: TObject; var Action: TCloseAction);
var
  F:Textfile;
  S: string;
begin
  FreeAndNil(INT_Accounts);
  FreeAndNil(INT_Clients);
  begin
    AssignFile(F, Extractfilepath(Application.exename)+'smsad.txt');
    Rewrite(F);
    S:=IPPort.Text;
    Writeln(F, S);
    S:=EPort.Text;
    Writeln(F, S);
    S:=(inttostr(sosmapcmdform.top));
    Writeln(F, S);
    S:=(inttostr(sosmapcmdform.left));
    Writeln(F, S);
    CloseFile(F);
  end;{Then use the text in the edits}
end;

// updateclients
procedure Tsosmapcmdform.UpdateClients;
var
  I : integer;
begin
  LBClients.Clear;
  for I := 0 to INT_Clients.Count - 1 do
    LBClients.Items.Add(IntToStr(INT_Clients[I].ID) + ' -> ' + INT_Clients[I].Name);
end;

// logclientread
procedure Tsosmapcmdform.LogClientRead(Message : string);
begin
  MStatus.Lines.Add(Message);
end;

// bconnectlick
procedure Tsosmapcmdform.BConnectClick(Sender: TObject);
var
 Binding : TIdSocketHandle;
begin
 INT_Clients.Clear;
 UpdateClients;
 Binding := IdTCPServer1.Bindings.Add;
 Binding.Port:=StrToInt(EPort.Text);
 Binding.IP := IPPort.Text;
 //'IP du serveur'; //'127.0.0.1' local test client+server real ip for network test
 IdTCPServer1.Active := true;
 if IdTCPServer1.Active then
  begin
   MStatus.Lines.Add('-SERVER STARTED- bound to IP ' + Binding.IP+
                     ' on port ' + IntToStr(Binding.Port));
   BConnect.Enabled := False;
   BDisconnect.Enabled := True;
   LPort.Enabled := False;
   EPort.Enabled := False;
  end;
end;

// bdisconnectclick
procedure Tsosmapcmdform.BDisconnectClick(Sender: TObject);
begin
 IdTCPServer1.Active := false;
 IdTCPServer1.Bindings.Clear;
 if not IdTCPServer1.Active then
  begin
   MStatus.Lines.Add('-SERVER STOPPED-');
   BConnect.Enabled := True;
   BDisconnect.Enabled := False;
   LPort.Enabled := True;
   EPort.Enabled := True;
  end;
end;




// bupdateclick
procedure Tsosmapcmdform.BUpdateClick(Sender: TObject);
var
numConnections:integer;
begin
numConnections := IdTCPServer1.Threads.LockList.Count;
IdTCPServer1.Threads.UnlockList; //to do quickly...to permit new conn
  SBStatus.Panels[0].Text := 'active connections : ' + IntToStr(numConnections);
  SBStatus.Panels[1].Text := 'clientlist.count : ' + IntToStr(INT_Clients.Count);
end;

// mstatuschange
procedure Tsosmapcmdform.MStatusChange(Sender: TObject);
begin
  if MStatus.Lines.Count < 2 then
    SBStatus.Panels[3].Text := IntToStr(MStatus.Lines.Count) + ' event logged'
  else
    SBStatus.Panels[3].Text := IntToStr(MStatus.Lines.Count) + ' events logged';
end;



//TIdTCPServer stuff ---------------------------------------------
procedure Tsosmapcmdform.IdTCPServer1Connect(AThread: TIdPeerThread);
begin
AThread.Connection.WriteLn('Welcome to the test server ;-)');
end;

procedure Tsosmapcmdform.IdTCPServer1Execute(AThread: TIdPeerThread);
var
  MessageID      : integer; //cardinal;
  Account        : TAccount;
  ClientInfo     : TClientInfo;
  Client         : TClient;
  ClientPosition : TClientPosition;
//  I              : integer;
  J              : integer;
  pack : TMemoryStream;

begin
//here we will manage the discussion in the thread of the client(Athread)
//first data of pack is *normally* the messageid, then depending on it

pack:=TMemoryStream.create;
AThread.Connection.ReadStream(pack,-1,false);
pack.Position:=0;
pack.Readbuffer(MessageID,sizeof(MessageID));
LogClientRead(MIDToStr(MessageID));

case MessageID of
 C2S_MSG_FirstConnect      : begin
                              pack.Readbuffer(Account,SizeOf(TAccount));
                              if INT_Accounts.AccountExists(Account.Name, Account.Password)
                               then MessageID := S2C_MSG_AccountValid
                               else MessageID := S2C_MSG_AccountInvalid;
                              //send back to client (no data part only the messageid)
                              AThread.Connection.WriteBuffer(MessageID, SizeOf(MessageID));
                             end;
 C2S_MSG_WantConnection    : begin
                              pack.Readbuffer(ClientInfo,SizeOf(ClientInfo));
                              Client := TClient.Create;
                              Client.ID := ClientInfo.ID;
                              Client.Address := AThread.Connection.Socket.Binding.PeerIP;
                              Client.Name := ClientInfo.Name;
                              Client.Position := NullVector;
                              Client.Direction := AffineVectorMake(0, 0, 1);
                              Client.Up := AffineVectorMake(0, 1, 0);
                              INT_Clients.Add(Client);
                              UpdateClients;
                              //send back to client (no data part only the messageid)
                              MessageID := S2C_MSG_Connected;
                              AThread.Connection.WriteBuffer(MessageID, SizeOf(MessageID));
                             end;
 C2S_MSG_WantDisconnection : begin
                              pack.Readbuffer(ClientInfo,SizeOf(ClientInfo));
                              INT_Clients.Delete(INT_Clients.FindID(ClientInfo.ID));
                              UpdateClients;
                              //message info "bye"
                              AThread.Connection.WriteLn('Bye ;-( see ya soon');
                              //disconnect the client
                              AThread.Connection.DisconnectSocket;
                             end;

{    C2S_MSG_StartSendingData  : begin
                                  MessageID := S2C_MSG_ReceiveBaseData;
                                  for I := 0 to Server.Socket.ActiveConnections - 1 do begin
                                    for J := 0 to INT_Clients.Count - 1 do begin
                                      ClientPosition.ID := INT_Clients[J].ID;
                                      ClientPosition.Position := INT_Clients[J].Position;
                                      ClientPosition.Direction := INT_Clients[J].Direction;
                                      ClientPosition.Up := INT_Clients[J].Up;
                                      Server.Socket.Connections[I].SendBuf(MessageID, SizeOf(MessageID));
                                      Server.Socket.Connections[I].SendBuf(ClientPosition, SizeOf(ClientPosition));
                                    end;
                                  end; }

 C2S_MSG_SendBaseData      : begin
                              pack.Readbuffer(ClientPosition,SizeOf(ClientPosition));
                              with INT_Clients[INT_Clients.FindID(ClientPosition.ID)] do begin
                                Position := ClientPosition.Position;
                                Direction := ClientPosition.Direction;
                                Up := ClientPosition.Up;
                              end;

                              MessageID := S2C_MSG_ReceiveBaseData;
                              for J := 0 to INT_Clients.Count - 1 do
                              
                               if INT_Clients[J].ID<>Client.ID then
                               //except for *this* client no?
                                begin
                                 ClientPosition.ID := INT_Clients[J].ID;
                                 ClientPosition.Position := INT_Clients[J].Position;
                                 ClientPosition.Direction := INT_Clients[J].Direction;
                                 ClientPosition.Up := INT_Clients[J].Up;
                                 //construct & distribute the position pack of other client(s)
                                 pack.clear;
                                 pack.Write(MessageID,sizeof(MessageID));
                                 pack.Write(ClientPosition,sizeof(ClientPosition));
                                 AThread.Connection.WriteStream(pack,true,true);
                                end;
                             end;
end;

 pack.free;
 //!! the Athread will be free after this procedure, so the "active connections" must be decrease
 //out of here to correctly show nb of active conn. in case of C2S_MSG_WantDisconnection
 BUpdate.Click;
end;



procedure Tsosmapcmdform.IdTCPServer1Exception(AThread: TIdPeerThread;
  AException: Exception);
begin
Mstatus.Lines.add(AException.Message);
end;

end.
