unit vrviewdisplayfrm;

{ 06.02.2k3 - folken - project started }

interface

uses
  Windows, Messages, SysUtils,Classes,
  Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  {net_types,  }
  vrrRemConMessages,
  net_account,
  GLScene,
  GLObjects, AsyncTimer, GLCadencer, GLMisc, GLWin32Viewer, AppEvnts,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdThreadComponent,IdThread, ExtCtrls, IdAntiFreezeBase, IdAntiFreeze;

type
  Tvrglsform = class(TForm)
    BConnect: TButton;
    BDisconnect: TButton;
    LHostname: TLabel;
    EHostname: TEdit;
    LPort: TLabel;
    EPort: TEdit;
    LName: TLabel;
    EName: TEdit;
    SBStatus: TStatusBar;
    EPassword: TEdit;
    SV3D: TGLSceneViewer;
    Scene: TGLScene;
    Cadencer: TGLCadencer;
    TNetTimer1: TAsyncTimer;
    lights: TGLDummyCube;
    objects: TGLDummyCube;
    clients: TGLDummyCube;
    main_light: TGLLightSource;
    main_cam: TGLCamera;
    main_plane: TGLPlane;
    local: TGLDummyCube;
    BEnableCadencer: TButton;
    AE: TApplicationEvents;
    TCadencer: TAsyncTimer;
    IdTCPClient1: TIdTCPClient;
    Lab_serverwelcome: TLabel;
    Label1: TLabel;
    Mstatus: TListBox;
    IdThreadComponent: TIdThreadComponent;
    IdAntiFreeze1: TIdAntiFreeze;
    LPassword: TLabel;
    StatusLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BConnectClick(Sender: TObject);
    procedure BDisconnectClick(Sender: TObject);
//    procedure ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ClientConnecting(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
//    procedure ClientWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
    procedure TNetTimer1Timer(Sender: TObject);
    procedure BEnableCadencerClick(Sender: TObject);
    procedure AEActivate(Sender: TObject);
    procedure AEDeactivate(Sender: TObject);
    procedure TCadencerTimer(Sender: TObject);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure IdTCPClient1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure IdThreadComponentRun(Sender: TIdCustomThreadComponent);
  private
    INT_ClientInfo         : TClientInfo;
    INT_ClientPosition     : TClientPosition;
    INT_Connected          : boolean;
    INT_WasCadencerEnabled : boolean;
    function GetOrCreatePlayer(ClientPosition : TClientPosition) : TGLBaseSceneObject;
  public
   //receving pack from listener thread after the conn process(all pos pack(s))
   Rpack:TMemoryStream;
  end;

var
  vrglsform: Tvrglsform;

implementation

uses
  VectorGeometry, Keyboard;

{$R *.dfm}


{ TClientMain }
// getorcreateplayer
//
function Tvrglsform.GetOrCreatePlayer(ClientPosition : TClientPosition) : TGLBaseSceneObject;
begin
  Result := Scene.FindSceneObject('player_' + IntToStr(ClientPosition.ID));
  if not Assigned(Result) then begin
    Result := TGLCube(clients.AddNewChild(TGLCube));
    Result.Name := 'player_' + IntToStr(ClientPosition.ID);
    TGLCustomSceneObject(Result).Material.FrontProperties.Diffuse.AsWinColor := ClientPosition.ID;
  end;
  Result.Position.AsAffineVector := ClientPosition.Position;
  Result.Direction.AsAffineVector := ClientPosition.Direction;
  Result.Up.AsAffineVector := ClientPosition.Up;
end;

// formcreate
//
procedure Tvrglsform.FormCreate(Sender: TObject);
begin
  Randomize;
  FillChar(INT_ClientInfo, SizeOf(INT_ClientInfo), 0);
  INT_ClientInfo.ID := Random($00FFFFFF);
  INT_ClientInfo.Address := '';
  INT_ClientInfo.Name := '';
  Caption := 'client [' + IntToStr(INT_ClientInfo.ID) + ']';
  INT_Connected := False;
  INT_ClientPosition.ID := INT_ClientInfo.ID;
  INT_ClientPosition.Position := NullVector;
  INT_ClientPosition.Direction := AffineVectorMake(0, 0, 1);
  INT_ClientPosition.Up := AffineVectorMake(0, 1, 0);
  GetOrCreatePlayer(INT_ClientPosition);

  Rpack:=TmemoryStream.create;
end;

// formclose
//
procedure Tvrglsform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 rpack.free;
end;

// bconnectclick
//
procedure Tvrglsform.BConnectClick(Sender: TObject);
begin
  IdTCPClient1.Host:=EHostname.Text;
  IdTCPClient1.Port:=StrToInt(EPort.Text);
  IdTCPClient1.Connect;//// add a timeout here if you wish, eg: Connect(3000) = timeout after 3 seconds.
end;

// bdisconnectclick
//
procedure Tvrglsform.BDisconnectClick(Sender: TObject);
var
  MessageID:Integer;
  Pack : TMemoryStream;
begin
if IdTCPClient1.Connected then
 try
  TNetTimer1.Enabled := False;
  Pack := TMemoryStream.Create;
  MessageID:=C2S_MSG_WantDisconnection;
  Pack.write(MessageID,sizeof(MessageID));
  Pack.write(INT_ClientInfo,sizeof(INT_ClientInfo));

  //send the disconnect pack request
  IdTCPClient1.Writestream(Pack,true,true);

  //read the bye message from the server
  Lab_serverwelcome.Caption:=IdTCPClient1.ReadLn;
  //byebye
  IdTCPClient1.Disconnect;

  TNetTimer1.Enabled:=false;

  BConnect.Enabled := True;
  LHostname.Enabled := True;
  EHostname.Enabled := True;
  LPort.Enabled := True;
  EPort.Enabled := True;
  LName.Enabled := True;
  EName.Enabled := True;
{  LPassword.Enabled := True;}
  EPassword.Enabled := True;
  BDisconnect.Enabled := False;

  Pack.free;
 except on E : Exception do ShowMessage(E.Message);
 end;
end;

// clientconnect
{procedure TClientMain.ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
var
  MessageID  : cardinal;
  Account    : TAccount;
begin
  MessageID := C2S_MSG_FirstConnect;
  FillChar(Account, SizeOf(TAccount), 0);
  Account.Name := EName.Text;
  Account.Password := EPassword.Text;
  Socket.SendBuf(MessageID, SizeOf(MessageID));
  Socket.SendBuf(Account, SizeOf(Account));
  SBStatus.SimpleText := 'connected';
end;
// clientconnecting
procedure TClientMain.ClientConnecting(Sender: TObject; Socket: TCustomWinSocket);
begin
//  SBStatus.SimpleText := 'connecting...';
end;
// clientdisconnect
procedure TClientMain.ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
//  BDisconnect.Click;
//  SBStatus.SimpleText := 'disconnected';
end;
// clientread
procedure TClientMain.ClientRead(Sender: TObject; Socket: TCustomWinSocket);
var
  MessageID      : cardinal;
  ClientPosition : TClientPosition;
begin
  Socket.ReceiveBuf(MessageID, SizeOf(MessageID));
  case MessageID of
    S2C_MSG_AccountValid    : begin
                                MessageID := C2S_MSG_WantConnection;
                                INT_ClientInfo.Name := EName.Text;
                                Socket.SendBuf(MessageID, SizeOf(MessageID));
                                Socket.SendBuf(INT_ClientInfo, SizeOf(INT_ClientInfo));
                              end;
    S2C_MSG_AccountInvalid  : begin
                                SBStatus.SimpleText := 'server: account does not exists';
                                Client.Active := False;
                              end;
    S2C_MSG_Connected       : begin
                                SBStatus.SimpleText := 'connected with [' + Socket.RemoteAddress + ']';
                                BConnect.Enabled := False;
                                LHostname.Enabled := False;
                                EHostname.Enabled := False;
                                LPort.Enabled := False;
                                EPort.Enabled := False;
                                LName.Enabled := False;
                                EName.Enabled := False;
                                LPassword.Enabled := False;
                                EPassword.Enabled := False;
                                BDisconnect.Enabled := True;
//                                MessageID := C2S_MSG_StartSendingData;
//                                Socket.SendBuf(MessageID, SizeOf(MessageID));
//                                Socket.SendBuf(INT_ClientPosition, SizeOf(INT_ClientPosition));
                                TNet.Enabled := True;
                              end;
    S2C_MSG_ReceiveBaseData : begin
//                                INT_Connected := True;
                                Socket.ReceiveBuf(ClientPosition, SizeOf(ClientPosition));
                                GetOrCreatePlayer(ClientPosition);
                              end;
  end;
end;
// clientwrite
//
procedure TClientMain.ClientWrite(Sender: TObject; Socket: TCustomWinSocket);
begin
//
end;

}
// cadencerprogress
//
procedure Tvrglsform.CadencerProgress(Sender: TObject; const deltaTime, newTime: Double);
begin
  if IsKeyDown('w') then
    local.Move(-20 * DeltaTime);
  if IsKeyDown('s') then
    local.Move(20 * DeltaTime);
  if IsKeyDown('a') then
    local.Turn(-200 * DeltaTime);
  if IsKeyDown('d') then
    local.Turn(200 * DeltaTime);
//  if INT_Connected then begin
    with local do begin
      INT_ClientPosition.Position := Position.AsAffineVector;
      INT_ClientPosition.Direction := Direction.AsAffineVector;
      INT_ClientPosition.Up := Up.AsAffineVector;
    end;
    GetOrCreatePlayer(INT_ClientPosition);
//  end;
end;

// tnettimer
//
procedure Tvrglsform.TNetTimer1Timer(Sender: TObject);
var
  MessageID : integer; //cardinal;
  pack:TMemoryStream;
begin
  pack:=TMemoryStream.Create;
  MessageID := C2S_MSG_SendBaseData;
  pack.Write(MessageID, SizeOf(MessageID));
  pack.Write(INT_ClientPosition, SizeOf(INT_ClientPosition));
  IdTCPClient1.WriteStream(pack,true,true);
  pack.Free;
end;

// benablecadencerclick
//
procedure Tvrglsform.BEnableCadencerClick(Sender: TObject);
begin
  TCadencer.Enabled := not TCadencer.Enabled;
end;

// aeactivate
//
procedure Tvrglsform.AEActivate(Sender: TObject);
begin
  TCadencer.Enabled := INT_WasCadencerEnabled;
end;

// aedeactivate
//
procedure Tvrglsform.AEDeactivate(Sender: TObject);
begin
  INT_WasCadencerEnabled := TCadencer.Enabled;
  TCadencer.Enabled := False;
end;

// tcadencertimer
//
procedure Tvrglsform.TCadencerTimer(Sender: TObject);
begin
  if IsKeyDown('w') then
    local.Move(-0.6);
  if IsKeyDown('s') then
    local.Move(0.6);
  if IsKeyDown('a') then
    local.Turn(-4);
  if IsKeyDown('d') then
    local.Turn(4);
//  if INT_Connected then begin
    with local do begin
      INT_ClientPosition.Position := Position.AsAffineVector;
      INT_ClientPosition.Direction := Direction.AsAffineVector;
      INT_ClientPosition.Up := Up.AsAffineVector;
    end;
    GetOrCreatePlayer(INT_ClientPosition);
//  end;
end;


//TIdTCPClient stuff-----------------------------------------------
procedure Tvrglsform.IdTCPClient1Connected(Sender: TObject);
 var
  Pack : TMemoryStream;//sending/receving stream
  MessageID  : integer;
  Account    : TAccount;

begin
  //read the greeting mess of the server
  Lab_serverwelcome.Caption:=IdTCPClient1.ReadLn;

  Pack := TMemoryStream.Create;

  MessageID := C2S_MSG_FirstConnect;
  FillChar(Account, SizeOf(TAccount), 0);
  Account.Name := EName.Text;
  Account.Password := EPassword.Text;

  //construct the pack to send
  Pack.write(MessageID,sizeof(MessageID));
  Pack.write(Account,sizeof(Account));

  //send the "first connect" pack
  IdTCPClient1.WriteStream(pack,true,true);

  //read the ID of the response
  IdTCPClient1.Readbuffer(MessageID,sizeof(MessageID));
  case MessageID of
    S2C_MSG_AccountValid    : begin
                               MessageID := C2S_MSG_WantConnection;
                               INT_ClientInfo.Name := EName.Text;
                               Mstatus.Items.Add('account validated ;-)');
                               //construct the "want connection" pack
                               Pack.Clear;
                               Pack.write(MessageID,sizeof(MessageID));
                               Pack.write(INT_ClientInfo,sizeof(INT_ClientInfo));
                               //send it
                               IdTCPClient1.WriteStream(pack,true,true);
                               //read the ID of the response
                               IdTCPClient1.Readbuffer(MessageID,sizeof(MessageID));
                               if MessageID=S2C_MSG_Connected then
                                begin
                                 SBStatus.SimpleText := 'connected with [' +
                                  IdTCPClient1.Socket.Binding.PeerIP + ']';
                                 BConnect.Enabled := False;
                                 LHostname.Enabled := False;
                                 EHostname.Enabled := False;
                                 LPort.Enabled := False;
                                 EPort.Enabled := False;
                                 LName.Enabled := False;
                                 EName.Enabled := False;
{                                 LPassword.Enabled := False;}
                                 EPassword.Enabled := False;
                                 BDisconnect.Enabled := True;

                                 //now spawn a listener thread for
                                 //the basic data exchange of player(s) pos
                                 //there is a component for that and it seems to works now
                                 //after a huge number of AV and blue screens....pfff
                                 IdThreadComponent.Active:=true;

                                 //Activate the timer to update client stuf...let's cadence!
                                TNetTimer1.Enabled := True;
                                end else
                                 begin
                                  //somefingue wrongue, the server don't want us?
                                 end;
                              end;
    S2C_MSG_AccountInvalid  : begin
                                Mstatus.Items.Add('account does not exists :-(');
                                SBStatus.SimpleText := 'server: account does not exists';
                                //Gracefully disconnected...catch by OnException on serverside;
                                IdTCPClient1.Disconnect;
                              end;
  end;
 pack.free;
end;

procedure Tvrglsform.IdTCPClient1Disconnected(Sender: TObject);
begin
  SBStatus.SimpleText := 'disconnected';
end;

procedure Tvrglsform.IdTCPClient1Work(Sender: TObject;
  AWorkMode: TWorkMode; const AWorkCount: Integer);
begin
  if AworkMode=wmWrite then//sending data from the peer.
     StatusLabel.Caption:=
       inttostr(AWorkCount+Strtoint(StatusLabel.Caption));
  { Mstatus.Items.Add(inttostr(AWorkCount)+'bytes sent');}
end;


//listener thread for pos pack(s)
procedure Tvrglsform.IdThreadComponentRun(Sender: TIdCustomThreadComponent);
var
MessageID:Integer;
ClientPosition:TClientPosition;
begin
while IdTCPClient1.Connected do
 begin
  //Lock somefingue;
  try
   rpack.Clear;
   IdTCPClient1.ReadStream(Rpack,-1,false);
   rPack.position:=0;
   Rpack.readbuffer(MessageID,sizeof(MessageID));
   Mstatus.Items.Add('S2C_MSG_ReceiveBaseData');
   if MessageID=S2C_MSG_ReceiveBaseData then
     begin
  //  INT_Connected := True;
      Rpack.ReadBuffer(ClientPosition, SizeOf(ClientPosition));
      GetOrCreatePlayer(ClientPosition);
     end;
  finally
  //Unlock somefingue;
  end;
 end;
end;





end.
